import { DomManipulation } from "@rxweb/dom";
import { BaseDomProvider } from "../core/base-dom-provider";
import { ModalClassConfig } from "./modal-class-config";
import { ComponentType } from './component-type';
export declare abstract class Modal extends BaseDomProvider {
    private domManipulation;
    private overLayElement;
    private popupElement;
    element: HTMLElement;
    designClass: ModalClassConfig;
    resolver: (x: Function, params: {
        [key: string]: any;
    }) => {
        element: HTMLElement;
        destroy: Function;
    };
    constructor();
    protected getDefaultTemplate(): {
        div: {
            class: any[];
            style: {
                [key: string]: any;
            };
        };
    };
    show(component: ComponentType<any>, params: {
        [key: string]: any;
    }): Promise<any>;
    hideResolver(resolve: Function, domManipulation: DomManipulation, overLayElement: DomManipulation, refResolver: any): (data: any) => void;
    hide(resolve: Function, data: any, domManipulation: any, overLayElement: any, refResolver: any): void;
}
